Broker_Recap = {}
local All_Fields =
{
    yourdps = { name = (RECAP_YOUR_DPS    or "Your DPS Out"),  color = "ff40ff40" },
    dpsin   = { name = (RECAP_MIN_DPS_IN  or "Total DPS In"),  color = "ffff4040" },
    dpsout  = { name = (RECAP_MIN_DPS_OUT or "Total DPS Out"), color = "ff40ff40" },
    yourhps = { name = (RECAP_YOUR_HPS    or "Your HPS"),      color = "ff80C0FF" },
    hpsout  = { name = (RECAP_MIN_HPS     or "Total HPS"),     color = "ff80C0FF" },
    petpct  = { name = (RECAP_YOUR_PET_PERCENT or "Your Pet Percent"),  color = "ffffffff" }
}

if not Broker_Recap_Options then
    Broker_Recap_Options = {}
    Broker_Recap_Options.Fields = {}
    local default_order = { "yourdps", "dpsin", "dpsout", "yourhps", "hpsout" }
    for i=1,#default_order do
        local f = All_Fields[ default_order[i] ]
        table.insert(Broker_Recap_Options.Fields, { k=default_order[i], enabled=true, color=f.color })
    end
--else
end
Broker_Recap_Options.Ver = "0.8"

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local RecapDataSource = ldb:NewDataObject("Broker_Recap", {
    type = "data source",
    icon = "Interface\\Addons\\Broker_Recap\\Images\\Status-Idle",
    text = "Broker_Recap",
})


function RecapDataSource:OnEnter()
---- display tooltip/menu with stats, pause/unpause, and show/hide
    --if not Broker_Recap.ToolTip then
        --local tt = CreateFrame("GameTooltip", "Broker_Recap_Tooltip")
        --Broker_Recap.ToolTip = tt
--
        --tt:SetOwner(UIParent, "ANCHOR_NONE")
        --tt.left = {}
        --tt.right = {}
--
        ---- FIXME: hard-coded 6
        --for i = 1, 6 do
            --tt.left[i] = tt:CreateFontString()
            --tt.left[i]:SetFontObject(GameFontNormal)
--
            --tt.right[i] = tt:CreateFontString()
            --tt.right[i]:SetFontObject(GameFontNormal)
            --tt:AddFontStrings(tt.left[i], tt.right[i])
        --end 
--
        --tt:AddLine("Foolishness",1,1,1,1)
    --end
----    Broker_Recap.ToolTip:SetPoint("TOPLEFT", 100,100);
    --Broker_Recap.ToolTip:SetWidth(100)
    --Broker_Recap.ToolTip:SetHeight(100)
    --Broker_Recap.ToolTip:Show();
end

function RecapDataSource:OnLeave()
    --Broker_Recap.ToolTip:Hide();
end

function RecapDataSource.OnClick(self, button)
-- Hide/Show recap
    if "LeftButton" == button then
        RecapFrame_Toggle()
    elseif "RightButton" == button then
        if not Broker_Recap.DropDown then
            Broker_Recap.DropDown = CreateFrame("Frame", "Broker_RecapDropDown", nil, "UIDropDownMenuTemplate") 
            --Broker_Recap.DropDown:SetScript("OnShow", function(self)
                --UIDropDownMenu_Initialize(self, Broker_Recap.RMB_Initialize, "MENU")
            --end)
        end

        -- There's no OpenDropDownMenu that forces it to show in the new place,
        -- so we have to check if the first Toggle opened or closed it
        UIDropDownMenu_Initialize(Broker_Recap.DropDown, Broker_Recap.RMB_Initialize, "MENU")
        ToggleDropDownMenu(1, nil, Broker_Recap.DropDown, "cursor", 0, 0);
        if not DropDownList1:IsShown() then
            ToggleDropDownMenu(1, nil, Broker_Recap.DropDown, "cursor", 0, 0);
        end
    end
end

Broker_Recap.FormatStrings = 
{ 
  "|c%s%9.1f|r",
  "|c%s%9.1f|r  |c%s%9.1f|r",
  "|c%s%9.1f|r  |c%s%9.1f|r  |c%s%9.1f|r",
  "|c%s%9.1f|r  |c%s%9.1f|r  |c%s%9.1f|r  |c%s%9.1f|r",
  "|c%s%9.1f|r  |c%s%9.1f|r  |c%s%9.1f|r  |c%s%9.1f|r  |c%s%9.1f|r"
}
Broker_Recap.WorkingTable =
{
  colors = {},
  values = {}
}

function RecapDataSource:Update()
    if self.state then
        self.icon = "Interface\\Addons\\Broker_Recap\\Images\\Status-" .. self.state
    end

    local text
    local n = 0

    for _,t in ipairs(Broker_Recap_Options.Fields) do
        if t.enabled and self[t.k] then
            n = n + 1
            Broker_Recap.WorkingTable.colors[n] = t.color
            Broker_Recap.WorkingTable.values[n] = self[t.k]
        end
    end

    if n > 0 then
        self.text = string.format( Broker_Recap.FormatStrings[n], 
            Broker_Recap.WorkingTable.colors[1], Broker_Recap.WorkingTable.values[1],
            Broker_Recap.WorkingTable.colors[2], Broker_Recap.WorkingTable.values[2],
            Broker_Recap.WorkingTable.colors[3], Broker_Recap.WorkingTable.values[3],
            Broker_Recap.WorkingTable.colors[4], Broker_Recap.WorkingTable.values[4],
            Broker_Recap.WorkingTable.colors[5], Broker_Recap.WorkingTable.values[5] )
    else
        self.text = ""
    end
end


-- Called roughly once a second by recap
-- Verions earlier than 4.35 do not pass yourhps,hpsout,petpct
function FuBarRecap_Update(state,yourdps,dpsin,dpsout,yourhps,hpsout,petpct)
  RecapDataSource.state = state
  RecapDataSource.viewtype = recap_user.View
  RecapDataSource.yourdps = yourdps
  RecapDataSource.dpsin = dpsin
  RecapDataSource.dpsout = dpsout

  if ( yourhps and hpsout and petpct ) then
    RecapDataSource.yourhps = yourhps
    RecapDataSource.hpsout = hpsout
    RecapDataSource.petpct = petpct
  elseif recap_temp then
    if RecapFu.viewtype == "Last" then
      RecapDataSource.yourhps = recap_temp.PlayerHPSLast
      RecapDataSource.hpsout = recap_temp.GroupHPSLast
      RecapDataSource.petpct = recap_temp.PlayerPetPercentLast
    else
      RecapDataSource.yourhps = recap_temp.PlayerHPSAll
      RecapDataSource.hpsout = recap_temp.GroupHPSAll
      RecapDataSource.petpct = recap_temp.PlayerPetPercentAll
    end
    RecapDataSource.petpct = RecapFu.petpct .. "%"
  end
  
  RecapDataSource:Update()
end


function Broker_Recap.SplitColorCode(str)
    local as, rs, gs, bs = string.match(str, "(%x%x)(%x%x)(%x%x)(%x%x)")
    return tonumber(as and "0x"..as)/255, tonumber(rs and "0x"..rs)/255, 
           tonumber(gs and "0x"..gs)/255, tonumber(bs and "0x"..bs)/255 
end

function Broker_Recap.RMB_Initialize()
    local info= UIDropDownMenu_CreateInfo();
    info.text = "Broker_Recap";
    info.isTitle = true;
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);

    info.isTitle = false;
    info.func = Broker_Recap.RMB_Toggle;
    info.disabled = nil;
    info.keepShownOnClick = true;
    info.isNotRadio = true;
    local A =Broker_Recap_Options.Fields 
    for i=1,#A do
        local k = A[i].k
        info.text = All_Fields[k].name
        info.hasColorSwatch = true
        info.opacity, info.r, info.g, info.b =  Broker_Recap.SplitColorCode(A[i].color)
        info.swatchFunc = function() 
            local t = {};
            t.r,t.g,t.b = ColorPickerFrame:GetColorRGB()
            --t.opacity = OpacitySliderFrame:GetValue()
            Broker_Recap.RMB_SetColor(A[i], t) 
        end
        --info.hasOpacity = 1;
        --info.opacityFunc = Broker_Recap.RMB_SetOpacity;
        info.cancelFunc = function(color)
            Broker_Recap.RMB_SetColor(A[i], color)
        end

        info.arg1 = A[i]
        info.value = A[i]
        info.field = k;
        info.checked= A[i].enabled;
        UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
    end
end

function Broker_Recap.RMB_Toggle(self, a1, a2, checked, ...)
    a1.enabled = not a1.enabled or nil
    RecapDataSource:Update()
end

function Broker_Recap.RMB_SetColor(key)
    local t = {};
    t.r,t.g,t.b = ColorPickerFrame:GetColorRGB()
    --t.opacity = OpacitySliderFrame:GetValue()
    Broker_Recap.RMB_SetColor(t)
end

--function Broker_Recap.RMB_SetOpacity()
--end
--
function Broker_Recap.RMB_SetColor(entry, color)
    entry.color = string.format("FF%02X%02X%02X", color.r*255, color.g*255, color.b*255)
    RecapDataSource:Update()
end
